﻿Imports System.IO
Imports System.Text.RegularExpressions

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        txtFile.Text = Application.StartupPath & "\test.txt"
    End Sub

    ' List the words in the file.
    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        ' Get the file's text.
        Dim txt As String = File.ReadAllText(txtFile.Text)

        ' Use regular expressions to replace characters
        ' that are not letters or numbers with spaces.
        Dim reg_exp As New Regex("[^a-zA-Z0-9]")
        txt = reg_exp.Replace(txt, " ")

        ' Split the text into words.
        Dim words() As String = txt.Split( _
            New Char() {" "c}, _
            StringSplitOptions.RemoveEmptyEntries)

        ' Use LINQ to get the unique words.
        Dim word_query = _
            (From word As String In words _
             Order By word _
             Select word).Distinct()

        ' Display the result.
        lstWords.DataSource = word_query.ToArray()
        lblSummary.Text = lstWords.Items.Count & " words"
    End Sub
End Class
